// This file is part of mzLogger.
//
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License version 2, as published by the
// Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// mzLogger. If not, see <http://www.gnu.org/licenses/>.
//
// This work is Copyright (C) 2016 by Josse van der Plaat
//
// Individual portions may be copyright by individual contributors, and are
// included in this collective work with permission of the copyright owners.

#ifndef VERBOSITY_H
#define VERBOSITY_H

#include <string>

#define implicit

struct Verbosity {
    enum V {
        None    = 0,
        Error   = 1,
        Warning = 2,
        Info    = 3,
        Debug   = 4,
        Trace   = 5
    } verbosity;
    implicit Verbosity(V verbosity = Warning)
        : verbosity(verbosity)
    { }
    explicit Verbosity(const std::string& str)
        : verbosity(FromString(str))
    { }

    static V FromString(const std::string& str);
    std::string toString() const;
};
bool operator==(const Verbosity& lhs, const Verbosity& rhs);
bool operator!=(const Verbosity& lhs, const Verbosity& rhs);
bool operator<( const Verbosity& lhs, const Verbosity& rhs);
bool operator>=(const Verbosity& lhs, const Verbosity& rhs);
bool operator<=(const Verbosity& lhs, const Verbosity& rhs);
bool operator>( const Verbosity& lhs, const Verbosity& rhs);


#endif /* VERBOSITY_H */
